package cn.com.infosec.asn1.x9;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERTaggedObject;
import java.util.Enumeration;

public class OtherInfo extends ASN1Encodable {
   private KeySpecificInfo keyInfo;
   private ASN1OctetString partyAInfo;
   private ASN1OctetString suppPubInfo;

   public OtherInfo(KeySpecificInfo keyInfo, ASN1OctetString partyAInfo, ASN1OctetString suppPubInfo) {
      this.keyInfo = keyInfo;
      this.partyAInfo = partyAInfo;
      this.suppPubInfo = suppPubInfo;
   }

   public OtherInfo(ASN1Sequence seq) {
      Enumeration seq1 = seq.getObjects();
      this.keyInfo = new KeySpecificInfo((ASN1Sequence)seq1.nextElement());

      while(seq1.hasMoreElements()) {
         DERTaggedObject var2;
         if ((var2 = (DERTaggedObject)seq1.nextElement()).getTagNo() == 0) {
            this.partyAInfo = (ASN1OctetString)var2.getObject();
         } else if (var2.getTagNo() == 2) {
            this.suppPubInfo = (ASN1OctetString)var2.getObject();
         }
      }

   }

   public KeySpecificInfo getKeyInfo() {
      return this.keyInfo;
   }

   public ASN1OctetString getPartyAInfo() {
      return this.partyAInfo;
   }

   public ASN1OctetString getSuppPubInfo() {
      return this.suppPubInfo;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10001 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var10001.add(this.keyInfo);
      ASN1OctetString var2;
      if ((var2 = this.partyAInfo) != null) {
         DERTaggedObject var3;
         var3 = new DERTaggedObject.<init>(0, var2);
         var1.add(var3);
      }

      DERTaggedObject var4;
      var4 = new DERTaggedObject.<init>(2, this.suppPubInfo);
      var1.add(var4);
      return new DERSequence(var1);
   }
}
